"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const Event_1 = __importDefault(require("../classes/Event"));
const Command_1 = __importDefault(require("../classes/Command"));
const Group_1 = __importDefault(require("../classes/Group"));
const SubCommand_1 = __importDefault(require("../classes/SubCommand"));
async function AutoRegister(app) {
    console.log("[F] Preparing to AutoRegister.");
    const files = await readFiles(app, process.cwd() + "/test");
    if (app.Common.isNull(files)) {
        console.log("[F] AutoRegister failed to fetch files.");
        process.exit();
    }
    for (const path of files) {
        if (!fs_1.default.existsSync(path)) {
            console.log("[F] AutoRegister could not find files: " + path);
            continue;
        }
        await handleFile(path, app);
    }
    return;
}
exports.default = AutoRegister;
async function handleFile(path, app) {
    try {
        const file = require(path).default;
        const Class = new file();
        if (Class instanceof SubCommand_1.default)
            return;
        if (Class instanceof Group_1.default) {
            console.log("[F] Loaded group: " + path);
            Class.___d(app);
            app.groups.set(Class.name, Class);
        }
        if (Class instanceof Event_1.default) {
            console.log("[F] Loaded event: " + path);
            Class.___d(app);
            app.client.on(Class.name, Class.run.bind(null));
        }
        if (Class instanceof Command_1.default) {
            console.log("[F] Loaded command: " + path);
            Class.___d(app);
            app.commands.set(Class.name, Class);
        }
    }
    catch (error) {
    }
    return;
}
async function readFiles(app, path) {
    let files = fs_1.default.readdirSync(path);
    if (app.Common.isNull(files)) {
        console.log("[F] Could not find files: " + path);
    }
    const filter = ["node_modules", "package.json", "package-lock.json", "tsconfig.json", "app.ts"];
    files = files.filter(r => !filter.includes(r.toLowerCase()));
    const paths = await mergePaths(path, files);
    let finalResult = [];
    for (const p of paths) {
        if (!fs_1.default.existsSync(p)) {
            console.log("[F] Could not find file/folder: " + p);
            continue;
        }
        if (fs_1.default.statSync(p).isDirectory()) {
            finalResult = finalResult.concat(await readFiles(app, p));
        }
        else {
            finalResult.push(p);
        }
    }
    return finalResult;
}
async function mergePaths(path, files) {
    const paths = [];
    for (const file of files) {
        paths.push(path + "/" + file);
    }
    return paths;
}
