"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
async function loadCommands(app) {
    const guilds = app.guilds;
    if (guilds.length == 0)
        return console.log("[F] Could not find any guilds!");
    for (const guildId of guilds) {
        const guild = app.Common.getGuild(guildId);
        if (app.Common.isNull(guild)) {
            console.log("[F] Could not find guild with id: " + guildId);
            continue;
        }
        guild?.commands.set(app.commands.map(r => {
            return {
                name: r.name,
                description: r.description,
                options: r.options
            };
            //@ts-ignore
        }).concat(app.groups.map(r => {
            return {
                name: r.name,
                description: r.description,
                options: r.__c.map(r => {
                    return {
                        type: "SUB_COMMAND",
                        name: r.name,
                        description: r.description,
                        options: r.options
                    };
                })
            };
        })));
    }
    return;
}
exports.default = loadCommands;
